/****************************************************************************************************************/
/*                                INCIO DAS DECLARAES DOS PROTTIPOS DAS FUNES                             */
/****************************************************************************************************************/

/*****************************************************************************************************************
  Descrio: Funo que aloca um vetor de nmeros reais com N elementos enviado via parametro
  Parmetros de entrada:
   -> Varivel do tipo nt: O Numero de elementos
  Retorno da funo:
   -> Varivel do tipo float: Um ponteiro para o inicio do vetor.
 *****************************************************************************************************************/
float *Alocar_Vetor_real(int );


/*****************************************************************************************************************
  Descrio: Funo que desaloca um vetor de nmeros reais
  Parmetros de entrada:
   -> Varivel do tipo int: O Numero de elementos
   -> Varivel do tipo float: O Ponteiro de inicio d
  Retorno da funo:
   -> Varivel do tipo float: Um ponteiro para o inicio do vetor.
 *****************************************************************************************************************/
float *Liberar_Vetor_real(float *);


/*****************************************************************************************************************
  Descrio: Funo que aloca um vetor de caracteres
  Parmetros de entrada:
   -> Varivel do tipo int: O Numero de elementos que ser alocado
  Retorno da funo:
   -> Varivel do tipo char: Um ponteiro para o inicio do vetor.
 *****************************************************************************************************************/
char *Alocar_Vetor_Caracter(int Numero_Elementos);

/*****************************************************************************************************************
  Descrio: Funo que aloca um vetor de inteiros
  Parmetros de entrada:
   -> Varivel do tipo int: O Numero de elementos que ser alocado
  Retorno da funo:
   -> Varivel do tipo int: Um ponteiro para o inicio do vetor.
 *****************************************************************************************************************/
int *Alocar_Vetor_inteiro(int );

/*****************************************************************************************************************
  Descrio: Funo que desaloca um vetor de caracteres
  Parmetros de entrada:
   -> Varivel do tipo char: O ponteiro do incio do vetor de caracteres
  Retorno da funo:
   -> Varivel do tipo char: Um ponteiro para o inicio do vetor de caracteres.
 *****************************************************************************************************************/
char *Liberar_Vetor_Caracter(char *);

/*****************************************************************************************************************
  Descrio: Funo que aloca uma string e altera o final enviado via parmetro
  Parmetros de entrada:
   -> Varivel do tipo char: Um vetor de caracteres
   -> Varivel do tipo char: Um vetor de caracteres
  Retorno da funo:
   -> Varivel do tipo char: Um ponteiro para o inicio do vetor de caracteres.
 *****************************************************************************************************************/
char *Aloca_String_Final (char [], char []);

/*****************************************************************************************************************
  Descrio: Funo que aloca um vetor de valores do tipo double
  Parmetros de entrada:
   -> Varivel do tipo int: O Numero de elementos a ser alocado
  Retorno da funo:
   -> Varivel do tipo double: Um ponteiro que indica o incio do vetor alocado
 *****************************************************************************************************************/
double *Alocar_Vetor_double(int );


/*****************************************************************************************************************
  Descrio: Funo que desaloca um vetor de valores double.
  Parmetros de entrada:
   -> Varivel do tipo double: Um ponteiro que contm o incio do vetor de valores double.
  Retorno da funo:
   -> Varivel do tipo double: Um ponteiro apontado para vazio.
 *****************************************************************************************************************/
double Liberar_Vetor_double(double *);

/*****************************************************************************************************************
  Descrio: Funo que desaloca um vetor de valores int.
  Parmetros de entrada:
   -> Varivel do tipo int: Um ponteiro que contm o incio do vetor de valores int.
  Retorno da funo:
   -> Varivel do tipo int: Um ponteiro apontado para vazio.
 *****************************************************************************************************************/
int *Liberar_Vetor_real(int *);

/****************************************************************************************************************/
/*                                  FIM DAS DECLARAES DOS PROTTIPOS DAS FUNES                              */
/****************************************************************************************************************/
