/****************************************************************************************************************/
/*                                  INCIO DAS DECLARAES DE DEFINES E CONSTANTES                              */
/****************************************************************************************************************/

typedef enum {Existente,Inexistente} Verifica; //Tipo declarado para verificao de existncia de valor

//Escopo da Funo
typedef struct No {

 int balanco;
 int Valor;
 No *esq, *dir;

} No;


/****************************************************************************************************************/
/*                                INCIO DAS DECLARAES DOS PROTTIPOS DAS FUNES                             */
/****************************************************************************************************************/


/*****************************************************************************************************************
  Descrio: Funo que desaloca todos os ns de determinada arvore binria
  Parmetros de entrada:
   -> Varivel do tipo No: Um ponteiro do incio da arvore
  Retorno da funo:
   -> Nenhum.
 *****************************************************************************************************************/
void Fim_Arvore( No **);


/*****************************************************************************************************************
  Descrio: Funo que imprime os valores armazenados de determinada rvore em percurso pr-ordem
  Parmetros de entrada:
   -> Varivel do tipo No: Um ponteiro do incio da arvore
  Retorno da funo:
   -> Nenhum.
 *****************************************************************************************************************/
void Pre_Ordem(No *&);

/*****************************************************************************************************************
  Descrio: Funo que calcula a altura de determinada rvore
  Parmetros de entrada:
   -> Varivel do tipo No: Um ponteiro do incio da arvore
  Retorno da funo:
   -> Varivel do tipo int: A altura da rvore.
 *****************************************************************************************************************/
int Altura(No *&);

/*****************************************************************************************************************
  Descrio: Funo que realiza todas as operaes para a manuteno da propriedade de arvore AVL
  Parmetros de entrada:
   -> Varivel do tipo No: Um ponteiro do incio da arvore
  Retorno da funo:
   -> Nenhum
 *****************************************************************************************************************/
void AVL(No *&);

/*****************************************************************************************************************
  Descrio: Funo que realiza a rotao direita dos ns da  arvore AVL
  Parmetros de entrada:
   -> Varivel do tipo No: Um ponteiro do incio da arvore
  Retorno da funo:
   -> Nenhum
 *****************************************************************************************************************/
void Rotacao_Direita(No *&);


/*****************************************************************************************************************
  Descrio: Funo que realiza a rotao Dupla direta dos ns da arvore AVL
  Parmetros de entrada:
   -> Varivel do tipo No: Um ponteiro do incio da arvore
  Retorno da funo:
   -> Nenhum
 *****************************************************************************************************************/
void Rotacao_Dupla_Direita(No *&);


/*****************************************************************************************************************
  Descrio: Funo que realiza a rotao Esquerda dos ns da rvore AVL
  Parmetros de entrada:
   -> Varivel do tipo No: Um ponteiro do incio da arvore
  Retorno da funo:
   -> Nenhum
 *****************************************************************************************************************/
void Rotacao_Esquerda(No *&);


/*****************************************************************************************************************
  Descrio: Funo que realiza a rotao Dupla Esquerda dos ns da rvore AVL
  Parmetros de entrada:
   -> Varivel do tipo No: Um ponteiro do incio da arvore
  Retorno da funo:
   -> Nenhum
 *****************************************************************************************************************/
void Rotacao_Dupla_Esquerda(No *&);

/*****************************************************************************************************************
  Descrio: Funo que realiza a rotao Dupla Esquerda dos ns da rvore AVL
  Parmetros de entrada:
   -> Varivel do tipo No: Um ponteiro do incio da arvore
  Retorno da funo:
   -> Nenhum
 *****************************************************************************************************************/
void Insere_Arvore(No **, int );


/*****************************************************************************************************************
  Descrio: Funo que realiza a busca por determinado elemento na arvore AVL
  Parmetros de entrada:
   -> Varivel do tipo No: Um ponteiro do incio da arvore
  Retorno da funo:
   -> Varivel do tipo Verifica:  Varivel contendo se  existe ou inexistente
 *****************************************************************************************************************/
Verifica Verifica_Repetido_Arvore(No *, int );



void Preencher_Arvore (No *&, char []);

void Preencher_Vetor_Valores_Arvore(No *&, int [],int &);

void Contador_De_Nos(No *&, int &);
/****************************************************************************************************************/
/*                                  FIM DAS DECLARAES DOS PROTTIPOS DAS FUNES                              */
/****************************************************************************************************************/
