#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <dirent.h>
#include "Manipulacao_Arquivos.h"
#include "Normalizacao.h"
#include "Alocacoes_Memoria.h"
#include "Arvore.h"

// Funo que faz a abertura de arquivo  para reescrita de nome enviado via parmetro para Leitura

FILE *Abre_Arquivo_Reescrita(char Nome_Arquivo []) {

    FILE *Ponteiro_Arquivo; // Ponteiro Arquivo

    Ponteiro_Arquivo = fopen(Nome_Arquivo, "a+");

    if (!(Ponteiro_Arquivo)) {
        printf("Erro na abertura do arquivo %s\n", Nome_Arquivo);
        exit(0);
    }

    return Ponteiro_Arquivo;
}

// Funo que faz a abertura de arquivo para leitura de nome enviado via parmetro para Leitura

FILE *Abre_Arquivo_Leitura(char Nome_Arquivo []) {

    FILE *Ponteiro_Arquivo; // Ponteiro Arquivo

    Ponteiro_Arquivo = fopen(Nome_Arquivo, "r");

    if (!(Ponteiro_Arquivo)) {
        printf("Erro na abertura do arquivo %s\n", Nome_Arquivo);
        exit(0);
    }

    return Ponteiro_Arquivo;
}

// Funo que faz a abertura de arquivo para escrita de nome enviado via parmetro para Escrita

FILE *Abre_Arquivo_Escrita(char Nome_Arquivo []) {

    FILE *Ponteiro_Arquivo; // Ponteiro Arquivo

    Ponteiro_Arquivo = fopen(Nome_Arquivo, "w+");

    if (!Ponteiro_Arquivo) {
        printf("Erro na abertura do arquivo %s\n", Nome_Arquivo);
        exit(0);
    }

    return Ponteiro_Arquivo;

}

/*Funo que faz a abertuda de pastas, conforme lido do arquivo "pastas.txt", e trata os
  arquivos conforme sua extenso                                                            */

void Normaliza_Pastas(void) {

    FILE *Ponteiro_Arquivo;
    No *Arvore= NULL;
    char Pasta_A_Ser_Lida [300], Endereco_Arquivo[300], *Nome_Arquivo_Final, Endereco_Arquivo_Final[300];
    struct dirent *drnt = NULL; //Varivel necessria para leitura do diretrio
    int Numero_de_Elementos = 0, *Valores_Arvore, i = 0;


    DIR *dir = NULL; // Inicializao varivel do diretrio
    strcpy(Endereco_Arquivo_Final,"");
    Ponteiro_Arquivo = Abre_Arquivo_Leitura("Pastas.txt"); //Abertura do arquivo que contm a(s) pasta(s) a serem lidas

    //Lao de repetio at o final do arquivo "Pastas.txt"
    do {
        fgets(Pasta_A_Ser_Lida, 300, Ponteiro_Arquivo);
        Pasta_A_Ser_Lida[strlen(Pasta_A_Ser_Lida)] = '\0';
        //Abertura da pasta
        dir = opendir(Pasta_A_Ser_Lida); //Leitura do diretrio
        fflush(stdin);

        if (!(dir)) {
            printf("Nao foi possivel abrir a pasta %s\n", Pasta_A_Ser_Lida);
            exit(0);
        }
        //Lao de repetio para ler todos os arquivos at o fim da pasta
        while (drnt = readdir(dir)) {
            if ((strstr(drnt-> d_name, ".txt")) && (!(strstr(drnt ->d_name, "Reunidos")))) {
                Ajusta_Nome_Arquivo(Pasta_A_Ser_Lida, drnt -> d_name, Endereco_Arquivo);
                //Normalizacao_Arquivo(Endereco_Arquivo);
                 Preencher_Arvore(Arvore,Endereco_Arquivo);
            }
        }

        Contador_De_Nos(Arvore,Numero_de_Elementos);
        Valores_Arvore = Alocar_Vetor_inteiro(Numero_de_Elementos);
        Preencher_Vetor_Valores_Arvore(Arvore, Valores_Arvore,i);
        Fim_Arvore(&Arvore);
        InsertionSort(Valores_Arvore,Numero_de_Elementos);
        strcpy(Endereco_Arquivo_Final,Pasta_A_Ser_Lida);
        strcat(Endereco_Arquivo_Final,"\\Valores_Reunidos.txt");
        Endereco_Arquivo_Final[strlen(Endereco_Arquivo_Final)] = '\0';

        Imprimir_Vetor_Em_Arquivo(Endereco_Arquivo_Final,Valores_Arvore, Numero_de_Elementos);
        Normalizacao_Arquivo(Endereco_Arquivo_Final);

        //Fecha Pasta
        closedir(dir);
    } while (!feof(Ponteiro_Arquivo));

    fclose(Ponteiro_Arquivo);
}

// Funo que concatena o endereo da pasta do arquivo, com o nome do arquivo para poder abri-lo

void Ajusta_Nome_Arquivo(char Endereco_Pasta[], char Nome_Arquivo [], char Endereco_Arquivo []) {

    strcpy(Endereco_Arquivo, ""); //Zera a String
    strcat(Endereco_Arquivo, Endereco_Pasta); // Concatena o endereo da psta do arquivo ex : endereo\..
    strcat(Endereco_Arquivo, "\\"); // Concatena o endereo da pasta do arquivo com
    strcat(Endereco_Arquivo, Nome_Arquivo); // Concacete o endereo da pasta do arquivo com o nome do arquivo. ex: endereco\nome.exe

}

// Funo que faz a contagem de elementos do tipo inteiro do arquivo de nome enviado via parametro

int Contador_Numero_Elementos_Arquivo(char Nome_Arquivo []) {

    int Numero_Elementos_Arquivo = 0, Auxiliar;
    FILE *Ponteiro_Arquivo;

    Ponteiro_Arquivo = Abre_Arquivo_Leitura(Nome_Arquivo);

    while (!feof(Ponteiro_Arquivo)) {
        fscanf(Ponteiro_Arquivo, "%d", &Auxiliar);
        Numero_Elementos_Arquivo++;
    }
    fclose(Ponteiro_Arquivo);

    return Numero_Elementos_Arquivo;
}

// Funo que preenche um Vetor de numeros reais com os dados lidos do arquivo enviado via pamametro

void Preencher_Vetor_Valores_Arquivo(float Vetor[], char Nome_Arquivo []) {

    FILE *Ponteiro_Arquivo;
    float Valor_Lido_Arquivo;
    int i;

    Ponteiro_Arquivo = Abre_Arquivo_Leitura(Nome_Arquivo);
    i = 0;
    while (!feof(Ponteiro_Arquivo)) {
        fscanf(Ponteiro_Arquivo, "%f", &Valor_Lido_Arquivo);
        Vetor[i] = Valor_Lido_Arquivo;
        i++;
    }

    fclose(Ponteiro_Arquivo);
}

void Imprimir_Vetor_Em_Arquivo (char Endereco_Arquivo[], int Vetor_Valores[], int Numero_Elementos) {

  int i;
  FILE *Arquivo = NULL;

   Arquivo = Abre_Arquivo_Escrita(Endereco_Arquivo);

   for ( i = 0; i < Numero_Elementos; i++) {
    fprintf(Arquivo,"%d\n",Vetor_Valores[i]);

  }

   fclose(Arquivo);
}
