#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#include "Manipulacao_Arquivos.h"
#include "Normalizacao.h"
#include "Alocacoes_Memoria.h"

//Funo que realiza o pr-processamento dos dados de um arquivo que tenha mais de 128 elementos

void Normalizacao_Arquivo(char Nome_Arquivo []) {

    int Numero_Elementos_Arquivo, Numero_Elementos_Janela;
    float *Vetor_Valores; // Ponteiro do tipo float para alocar o vetor
    double Media, Variancia, *Janelas; // Ponteiro do tipo double para alocar o vetor respectivo as janelas calculadas

    //Chamada para saber o nmero de elementos do vetor
    Numero_Elementos_Arquivo = Contador_Numero_Elementos_Arquivo(Nome_Arquivo);
    // Aloca um vetor de valores do tipo float para armazenar os valores do arquivo
    Vetor_Valores = Alocar_Vetor_real(Numero_Elementos_Arquivo);
    // Funo que preenche o vetor de nmeros tipo float com os valores lidos do arquivo a ser normalizado
    Preencher_Vetor_Valores_Arquivo(Vetor_Valores, Nome_Arquivo);
    //Chamada da funo que calcula a janela de energia, aloca e armazena os valores em um vetor do tipo double
    Janelas = Janela_Energia(Numero_Elementos_Arquivo, Vetor_Valores);
    //Chamada da funo para calcular o nmero de janelas para este arquivo
    Numero_Elementos_Janela = Calculo_Numero_Janelas_Energia(Numero_Elementos_Arquivo);
    //Chamada da funo Media, fazendo a mdia dos valores da janela de energia anteriormente calculada
    Media = Calculo_Media_Double(Janelas, Numero_Elementos_Janela);
    //Chamada da funo de calculo de varincia, que calcula dentre os valores das janelas de energia
    Variancia = Calculo_Variancia(Janelas, Media, Numero_Elementos_Janela);
    /* a Chamada da funo Padronizao, que com todos os valores calculados, imprime em um arquivo de sada
     os valores normalizados, respectivo ao arquivo processado, com a palavra "(normalizado)" anexado            */
    Padronizacao(Janelas, Media, Variancia, Numero_Elementos_Janela, Nome_Arquivo);
    //Chamada da Funo para liberar o vetor alocado com os valores lidos do arquivo
    Liberar_Vetor_real(Vetor_Valores);
    //Chamada da funo para liberar o vetor do tipo double usado para as janelas de energia
    Liberar_Vetor_double(Janelas);
}



//Funo para calcular a mdia dentro de um vetor de nmeros reais

float Calculo_Media_Real(float Vetor[], int Numero_Elementos) {

    int i;
    float Soma_Valores = 0, Media;

    for (i = 0; i < Numero_Elementos; i++) {
        Soma_Valores = Soma_Valores + Vetor[i];
    }

    Media = Soma_Valores / Numero_Elementos;

    return (Media);
}



//Funo para calcular a mdia dentro de um vetor de nmeros double

double Calculo_Media_Double(double Vetor[], int Numero_Elementos) {

    int i;
    double Soma_Valores = 0, Media;

    for (i = 0; i < Numero_Elementos; i++) {
        Soma_Valores = Soma_Valores + Vetor[i];
    }

    Media = Soma_Valores / Numero_Elementos;

    return (Media);
}

//Funo para calcular  a varincia dos valores contidos no vetor enviado via parametro

double Calculo_Variancia(double Vetor_Valores[], double Media, int Numero_Elementos) {

    double Variancia, Soma_Quadrado_Desvios = 0, Desvio;
    int i;


    for (i = 0; i < Numero_Elementos; i++) {
        Desvio = (Vetor_Valores[i] - Media);
        Soma_Quadrado_Desvios = Soma_Quadrado_Desvios + pow(Desvio, 2);
    }
    Variancia = Soma_Quadrado_Desvios / Numero_Elementos;

    return (Variancia);
}

// Funo que normaliza o Arquivo enviado via parametro

void Padronizacao(double Vetor_Valores [], double Media, double Variancia, int Numero_Elementos, char Nome_Arquivo []) {

    FILE *Arquivo_Saida;
    char *Nome_Arquivo_Saida;
    int i;
    double Valor_Normalizado;

    Nome_Arquivo_Saida = Aloca_String_Final(Nome_Arquivo, "(Normalizado)");
    Arquivo_Saida = Abre_Arquivo_Escrita(Nome_Arquivo_Saida);
    for (i = 0; i < Numero_Elementos; i++) {
        Valor_Normalizado = (Vetor_Valores[i] - Media) / Variancia;
        fprintf(Arquivo_Saida, "%lf\n", Valor_Normalizado);

    }
    Liberar_Vetor_Caracter(Nome_Arquivo_Saida);
    fclose(Arquivo_Saida);
}

//Funo que calcula as janelas de energia dos valores lidos do arquivo a ser processado

double *Janela_Energia(int Numero_Elementos, float Vetor_Valores[]) {

    int i = 0, j = 0, k = 0, Tamanho_Vetor_Janela;
    double Soma_Janela, Janela;
    double *Vetor_Janela;

    Tamanho_Vetor_Janela = Calculo_Numero_Janelas_Energia(Numero_Elementos);
    Vetor_Janela = Alocar_Vetor_double(Tamanho_Vetor_Janela);

    if (Numero_Elementos < 128) {
        printf("Numero de elementos invalido para Janela de Energia!!!\n");
        exit(0);
    }
    while (i < Numero_Elementos) {
        j = 0;
        Soma_Janela = 0;
        while ((j < 128) && (i < Numero_Elementos)) {
            Soma_Janela += Vetor_Valores[i];
            j++;
            i++;
        }
        Janela = Soma_Janela / j;
        Vetor_Janela[k] = Janela;
        k++;
    }

    return (Vetor_Janela);
}

//Funo que calcula o Numero de Janelas de Energia baseado no nmero de elementos

int Calculo_Numero_Janelas_Energia(int Numero_Elementos) {

    int Numero_Janelas;
    int Verificador;

    Verificador = Numero_Elementos % 128; //Verificao se a diviso por 128 ser o nmero inteiro exato
    Numero_Janelas = Numero_Elementos / 128; // Diviso do nmero de elementos para saber o nmero de janelas de energia

    if (Verificador == 0) {
        return Numero_Janelas;
    } else {
        Numero_Janelas += 1;
    }

    return (Numero_Janelas);
}


void InsertionSort(int Vetor_Valores[], int Tamanho_Vetor) {

    int j, i, key;

    for (j = 1; j < Tamanho_Vetor; j++) {
        key = Vetor_Valores[j];
        i = j - 1;
        while (i >= 0 && Vetor_Valores[i] > key) {
            Vetor_Valores[i + 1] = Vetor_Valores[i];
            i = i - 1;
        }
        Vetor_Valores[i + 1] = key;
    }
}
